package ij2x.plugin.frame;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Insets;
import java.awt.MenuShortcut;
import java.awt.Rectangle;
import java.awt.Graphics2D;
import java.awt.Shape;
import java.text.AttributedCharacterIterator;
import java.text.AttributedString;
import java.awt.Toolkit;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemEvent;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.WindowEvent;

import java.awt.font.FontRenderContext;
import java.awt.font.TextLayout;
import java.awt.font.TextHitInfo;

import java.awt.datatransfer.Clipboard;																																																																																																																																																																																																																																																									 import java.util.*;
import java.awt.datatransfer.Transferable;																																																																																																																																																																																																																																																									 import java.util.*;
import java.awt.datatransfer.ClipboardOwner;																																																																																																																																																																																																																																																									 import java.util.*;
import java.awt.print.PrinterException;
import java.awt.print.PrinterJob;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import java.io.BufferedWriter;
import java.io.BufferedReader;
import java.io.CharArrayReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.File;
import java.io.IOException;

import java.net.URL;

import javax.print.attribute.HashPrintRequestAttributeSet;
import javax.print.attribute.PrintRequestAttributeSet;

import javax.swing.event.DocumentListener;
import javax.swing.event.DocumentEvent;
import javax.swing.event.UndoableEditEvent;
import javax.swing.event.UndoableEditListener;
import javax.swing.text.JTextComponent;
import javax.swing.text.TextAction;
import javax.swing.text.Document;
import javax.swing.text.Segment;
import javax.swing.text.StringContent;

import javax.swing.text.MutableAttributeSet;
import javax.swing.text.DefaultStyledDocument;
import javax.swing.text.StyleContext;
import javax.swing.text.Highlighter;
import javax.swing.text.NavigationFilter;
import javax.swing.text.StyledEditorKit;

import javax.swing.undo.CannotUndoException;
import javax.swing.undo.CannotRedoException;
import javax.swing.undo.UndoManager;
import javax.swing.Action;
import javax.swing.AbstractAction;
import javax.swing.AbstractButton;
import javax.swing.Box;
import javax.swing.ButtonGroup;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JComponent;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JTextPane;
import javax.swing.JToggleButton;
import javax.swing.JViewport;
import javax.swing.JToolBar;
import javax.swing.KeyStroke;

import ij.IJ;
import ij.ImageJ;
import ij.Menus;
import ij.WindowManager;
import ij.IJ;
import ij.gui.GenericDialog;
import ij.gui.SaveChangesDialog;
import ij.Prefs;
import ij.util.Tools;

import ij.macro.Interpreter;
import ij.macro.MacroConstants;
import ij.macro.MacroRunner;
import ij.macro.Program;
import ij.plugin.MacroInstaller;
import ij.plugin.NewPlugin;
import ij.io.SaveDialog;
import ij.plugin.frame.*;
//import ij.plugin.frame.jedit.JEditTextArea;

import ij2x.print.PrintableDocument;

import javax.swing.JLabel;
import javax.swing.JPanel;
import java.awt.event.MouseWheelListener;
import java.awt.event.MouseWheelEvent;
import java.awt.geom.Rectangle2D;
import java.awt.GridBagLayout;
import java.awt.LayoutManager;
//import javax.swing.text.Style;
import java.awt.event.AdjustmentEvent;
import java.awt.event.AdjustmentListener;
import javax.swing.JScrollBar;
import javax.swing.ScrollPaneConstants;
import javax.swing.border.BevelBorder;
import javax.swing.border.Border;
import javax.swing.BorderFactory;
import javax.swing.JTextArea;
import java.awt.geom.AffineTransform;
import java.awt.font.TextAttribute;


/** This is a simple TextArea based editor for editing and compiling plugins. */
public class Editor extends PlugInFrame implements
        MouseListener, MouseWheelListener, KeyListener, DocumentListener, ClipboardOwner, MacroConstants, KeyCode {

    private static ResourceBundle resources;
    public static final int MAX_SIZE = 28000, MAX_MACROS=50, XINC=10, YINC=18;
    static final String FONT_SIZE = "editor.font.size";
    static final String FONT_MONO= "editor.font.mono";
    static final int PAGE_SCROLL = 18+1;
    private JTextComponent editor;

    private String path;
    private boolean changes;
    private static String searchString = "";
    private static int lineNumber = 1;
    private static int xoffset, yoffset;
    private static int nWindows;
    private JMenu fileMenu, editMenu;
    private Properties p = new Properties();
    //private int[] macroStarts;
    //private String[] macroNames;
    private JMenuBar mb = new JMenuBar();
    private JScrollPane scrollPane;
    private JScrollBar scrollBar;
    private JViewport port;
    private JMenu macrosMenu;
    //private int nMacros;
    private Program pgm;
    private int eventCount=0;
    //private String shortcutsInUse;
    //private int inUseCount;
    //private int nShortcuts;
    private MacroInstaller installer;
    private static String defaultDir;
    //private int[] sizes = {8, 9, 10, 11, 12, 14, 16, 18, 20, 24, 36, 48, 60, 72};
    private int[] sizes = {6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 20, 22, 24, 26, 28, 30};
    private int fontSize = (int)Prefs.get(FONT_SIZE, 6);
    private TextLayout layout;
    private FontRenderContext frc;
    private static boolean caseSensitive = true;
    private static boolean wholeWords;
    private JCheckBoxMenuItem monospaced;
    private boolean dontShowWindow;
    private JPopupMenu pm;
    boolean enable=true;
    private Hashtable<Object, Action> commands;
    private Hashtable<String, JMenuItem> menuItems;
    private JMenuBar menubar;
    private JToolBar toolbar;
    //private JComponent westOff;
    private JLabel statusLabel;
    private ButtonGroup group = new ButtonGroup();
    //private boolean isBold, isItalic;
    private boolean isMacroWindow;
    //private Position position;
    private Highlighter highlighter;
    private NavigationFilter navigation;
    private int num =0, length=0, lnwidth=40;
    private String[] lines = new String[1];
    private int[] llength = new int[1];
    private int[] lwidth = new int[1];
    private int[] offset = new int[1];
    //private char[][] chars = new char[1][1];
    private int row = 1, lineBegin=1, lineEnd=1;
    private StringBuilder sb, lnsb;
    private String text = "";
    private String lntext = "";
    private BevelBorder bb ;//new BevelBorder for LOWER or RAISED type
    private Border grayBorder = BorderFactory.createBevelBorder(bb.RAISED, Color.gray, Color.lightGray);
    //private Border rasedBorder = BorderFactory.createBevelBorder(bb.RAISED, Color.lightGray,Color.lightGray );
    private Font curFont;
    private FontMetrics fm;
    private int curRow=1;
    private int oldrow=1;
    //private JEditTextArea jedit;
    private Document doc;
    private Segment segment;
    private AttributedString attribString;
    private AttributedCharacterIterator attribCharIterator;

        static {
            try {
                resources = ResourceBundle.getBundle("ij2x.plugin.frame.resources.MonoEditor",
                                                     Locale.getDefault());
            } catch (MissingResourceException mre) {
                System.err.println("resources/MonoEditor.properties not found");
                System.exit(1);
            }
        }
        public void run(String arg) {

           commands = new Hashtable<Object, Action>();
           menuItems = new Hashtable<String, JMenuItem>();
           editor = createEditor();
           frc = new FontRenderContext(null, false, false);
           //lineNoEditor = createLNoEditor();
           doc = editor.getDocument();
           doc.addDocumentListener(this);
           if (IJ.isMacOSX() && !IJ.isJava14())
                   editor.setFont(new Font("SansSerif",Font.PLAIN,12));
           addKeyListener(IJ.getInstance());  // ImageJ handles keyboard shortcuts
           Action[] actions = getActions();
           for (int i = 0; i < actions.length; i++) {
               Action a = actions[i];
               //System.out.println("Action.NAME("+i+")="+a.getValue(Action.NAME));
               commands.put(a.getValue(Action.NAME), a);
           }
           editor.addMouseListener(this);
           editor.addMouseWheelListener(this);
           editor.addKeyListener(this);

           doc.addUndoableEditListener(undoHandler);

           toolbar = (JToolBar)createToolbar();
           container.add(toolbar, BorderLayout.NORTH);
           JMenuBar menuBar = createMenubar();
           this.setJMenuBar(menuBar);
           scrollPane = new JScrollPane();

           port=scrollPane.getViewport();

           port.add(editor, null);
           scrollPane.setBorder(grayBorder);
           scrollBar=scrollPane.getVerticalScrollBar();
           container.add(scrollPane, BorderLayout.CENTER);

           statusLabel=new JLabel(" ");
           JPanel statusPanel = createStatusBar(statusLabel);
           container.add(statusPanel, BorderLayout.SOUTH);
           createPopupMenus();
           this.setSize(600, 400);
           positionWindow();
           IJ.register(Editor.class);

        }
        public Editor() {
            super("Editor");
            WindowManager.addWindow(this);
            run("Editor");
            IJ.register(Editor.class);
        }

        /** Override Container getInsets() to make room for some text above the image. */
        public Insets getInset(int top, int left) {
                Insets insets = super.getInsets();
                insets = new Insets(insets.top+top, insets.left+left, insets.bottom, insets.right);
                return insets;
        }
        /**
         * Create an editor to represent the given document.
         */
        protected JTextComponent createEditor() {
            StyleContext sc = new StyleContext();
            //Style defaultStyle = sc.getStyle(StyleContext.DEFAULT_STYLE);
            DefaultStyledDocument doc = new DefaultStyledDocument(sc);
            JTextPane txtcomp = new JTextPane(doc);
            txtcomp.setDragEnabled(true);
            txtcomp.setMargin(getInset(0, 0));
            return txtcomp;
        }
        /**
         * Fetch the editor contained in this panel
         */
        protected JTextComponent getEditor() {
            return editor;
        }
        /**
        * Fetch the list of actions supported by this
        * editor.  It is implemented to return the list
        * of actions supported by the embedded JTextComponent
        * augmented with the actions defined locally.
        */
       public Action[] getActions() {
           return TextAction.augmentList(editor.getActions(), defaultActions);
       }
       protected Action getAction(String cmd) {
           return commands.get(cmd);
       }
       protected String getResourceString(String nm) {
           String str;
           try {
               str = resources.getString(nm);
           } catch (MissingResourceException mre) {
               str = null;
           }
           return str;
       }

       /**
        * Create a status bar
        */
       protected JPanel createStatusBar(JLabel label){
          JPanel panel = new JPanel();
          panel.setLayout(new BorderLayout());
          panel.add(BorderLayout.EAST, label);
         return panel;
       }

       protected Container getToolbar() {
          return toolbar;
      }

      protected JMenuBar getMenubar() {
          return menubar;
      }

      /**
       * Fetch the menu item that was created for the given
       * command.
       * @param cmd  Name of the action.
       * @returns item created for the given command or null
       *  if one wasn't created.
       */
      protected JMenuItem getMenuItem(String cmd) {
          return menuItems.get(cmd);
      }

      protected URL getResource(String key) {
           String name = getResourceString(key);
           if (name != null) {
               URL url = this.getClass().getResource(name);
               return url;
           }
           return null;
       }

       /**
        * Take the given string and chop it up into a series
        * of strings on whitespace boundaries.  This is useful
        * for trying to get an array of strings out of the
        * resource file.
        */
       protected String[] tokenize(String input) {
           Vector<String> v = new Vector<String>();
           StringTokenizer t = new StringTokenizer(input);
           String cmd[];

           while (t.hasMoreTokens())
               v.addElement(t.nextToken());
           cmd = new String[v.size()];
           for (int i = 0; i < cmd.length; i++)
               cmd[i] = v.elementAt(i);

           return cmd;
       }

       /**
        * Resets the undo manager.
        */
       protected void resetUndoManager() {
           undo.discardAllEdits();
           undoAction.update();
           redoAction.update();
       }

       /**
        * Create the toolbar.  By default this reads the
        * resource file for the definition of the toolbar.
        */
       private Component createToolbar() {
           toolbar = new JToolBar();
           boolean isbutton=true;
           String[] toolKeys = tokenize(getResourceString("toolbar"));
           for (int i = 0; i < toolKeys.length; i++) {
               if (toolKeys[i].equals("-")) {
                   toolbar.add(Box.createHorizontalStrut(5));
               } else {
                   String bot= getResourceString(toolKeys[i] + "Button");
                   if(bot!=null){
                       Boolean shifts = Boolean.valueOf(bot);
                       isbutton = shifts.booleanValue();
                   }//else isbutton=false;
                   toolbar.add(createTool(toolKeys[i], isbutton));
               }
           }
           toolbar.add(Box.createHorizontalGlue());
           return toolbar;
       }

       /**
        * Hook through which every toolbar item is created.
        */
       protected Component createTool(String key, boolean isbutton) {
           return createToolbarButton(key, isbutton);
       }

       /**
        * Create a button to go inside of the toolbar.  By default this
        * will load an image resource.  The image filename is relative to
        * the classpath (including the '.' directory if its a part of the
        * classpath), and may either be in a JAR file or a separate file.
        *
        * @param key The key in the resource file to serve as the basis
        *  of lookups.
        */
       protected Component createToolbarButton(String key, boolean isbutton) {
           URL url = getResource(key + imageSuffix);
           boolean enabled=true;
           //System.out.println("url=" +url);
           AbstractButton b = null;
           if(isbutton){
              JButton jb = new JButton(new ImageIcon(url)) {
                   public float getAlignmentY() { return 0.5f; }
               };b=jb;}
           else{
              JToggleButton jtb = new JToggleButton("", new ImageIcon(url), false) {
                   public float getAlignmentY() { return 0.5f; }
               };b=jtb;}
           b.setRequestFocusEnabled(false);
           b.setMargin(new Insets(1,1,1,1));

           String astr = getResourceString(key + actionSuffix);
           if (astr == null) {
               astr = key;
           }
           Action a = getAction(astr);
           if (a != null) {
               b.setActionCommand(astr);
               a.addPropertyChangeListener(createActionChangeListener(b));
               b.addActionListener(a);
           } else {
               b.setEnabled(false);
           }

           String tip = getResourceString(key + tipSuffix);
           if (tip != null) {
               b.setToolTipText(tip);
           }
           String sev = getResourceString(key + undoSuffix);
           if(sev!=null){
               Boolean ev = Boolean.valueOf(sev);
               enabled = ev.booleanValue();
               b.setEnabled(enabled);
           }
           //if(astr.equals("Undo") || astr.equals("Redo"))
           //    b.setEnabled(enabled);

           return b;
       }

       /**
        * Create the menubar for the app.  By default this pulls the
        * definition of the menu from the associated resource file.
        */
       protected JMenuBar createMenubar() {
           JMenuItem mi;
           JMenuBar mb = new JMenuBar();

           String[] menuKeys = tokenize(getResourceString("menubar"));
           for (int i = 0; i < menuKeys.length; i++) {
               //System.out.println("menuKeys[i]="+menuKeys[i]);
               if(menuKeys[i].equals("color")){mb.add(createColorMenu(menuKeys[i]));continue;}
               JMenu m = createMenu(menuKeys[i]);
               if (m != null) {
                   mb.add(m);
               }
           }
           this.menubar = mb;
           return mb;
       }

       void createCheckBoxMenuItem(JMenu menu, String colorName, Color color, boolean state){
           ActionListener a;
           JCheckBoxMenuItem cb;
           String colorname=colorName.toLowerCase();
           cb = new JCheckBoxMenuItem(resources.getString(colorName));
           cb.setHorizontalTextPosition(JButton.RIGHT);
           cb.setIcon(new ColoredSquare(color));
           a = new StyledEditorKit.ForegroundAction("set-foreground-"+ colorname, color);
           cb.addActionListener(a);
           group.add(cb);
           cb.setState(state);
           menu.add(cb);
       }
       /**
         * Create a color menu for the app.  By default this pulls the
         * definition of the menu from the associated resource file.
         */
     JMenu createColorMenu(String key) {
         JMenu menu = new JMenu(getResourceString(key + labelSuffix));
         createCheckBoxMenuItem(menu, "Red", Color.red, false);
         createCheckBoxMenuItem(menu, "Green", Color.green, false);
         createCheckBoxMenuItem(menu, "Blue", Color.blue, false);
         menu.addSeparator();
         createCheckBoxMenuItem(menu, "Black", Color.black, true);

         return menu;
     }
      /**
        * Create a menu for the app.  By default this pulls the
        * definition of the menu from the associated resource file.
        */
       protected JMenu createMenu(String key) {
           boolean shift = false;
           String[] itemKeys = tokenize(getResourceString(key));
           int[] shortCutitemKeys = new int[itemKeys.length];
           int j=0;
           JMenu menu = new JMenu(getResourceString(key + "Label"));
           for (int i = 0; i < itemKeys.length; i++) {
               if (itemKeys[i].equals("-")) {
                   menu.addSeparator();
               } else if(itemKeys[i].equals("monospaced")){
                   JCheckBoxMenuItem checkmi = createCheckBoxMenuItem(itemKeys[i]);
                   monospaced=checkmi;
                   menu.add(checkmi);
               }
               else{
                   String sc = getResourceString(itemKeys[i] + "Shortcut");
                   if(sc!=null){
                       for(j=0; j<shortcutKeys.length;j++){
                           if (sc.equals(shortcutKeys[j]))
                               shortCutitemKeys[i] = shortcutKeyi[j];
                       }
                   }
                   String ssc= getResourceString(itemKeys[i] + "ShiftShortcut");
                   if(ssc!=null){
                       Boolean shifts = Boolean.valueOf(ssc);
                       shift = shifts.booleanValue();
                   }else shift=false;
                   //System.out.println(" shortCutitemKeys["+i+"]="+ shortCutitemKeys[i]);
                   JMenuItem mi = createMenuItem(itemKeys[i], shortCutitemKeys[i], shift);
                   menu.add(mi);
               }
           }
           if(menu.getText().equals("File"))
                this.fileMenu=menu;
            else if(menu.getText().equals("Edit"))
                this.editMenu=menu;
           return menu;
       }

       /**
        * This is the hook through which all menu items are
        * created.  It registers the result with the menuitem
        * hashtable so that it can be fetched with getMenuItem().
        * @see #getMenuItem
        */
       protected JMenuItem createMenuItem(String cmd) {
           JMenuItem mi = new JMenuItem(getResourceString(cmd + labelSuffix));
           URL url = getResource(cmd + imageSuffix);
           if (url != null) {
               mi.setHorizontalTextPosition(JButton.RIGHT);
               mi.setIcon(new ImageIcon(url));
           }
           String astr = getResourceString(cmd + actionSuffix);
           if (astr == null) {
               astr = cmd;
           }
           //System.out.println("astr=" + astr);
           mi.setActionCommand(astr);
           Action a = getAction(astr);
           if (a != null) {
               mi.addActionListener(a);
               a.addPropertyChangeListener(createActionChangeListener(mi));
               mi.setEnabled(a.isEnabled());
           } else {
               mi.setEnabled(false);
           }
           menuItems.put(cmd, mi);
           return mi;
       }

       /**
        * This is the hook through which all menu items are
        * created.  It registers the result with the menuitem
        * hashtable so that it can be fetched with getMenuItem().
        * @see #getMenuItem
        */
       protected JCheckBoxMenuItem createCheckBoxMenuItem(String cmd) {
           JCheckBoxMenuItem mi = new JCheckBoxMenuItem(getResourceString(cmd + labelSuffix));
           URL url = getResource(cmd + imageSuffix);
           if (url != null) {
               mi.setHorizontalTextPosition(JButton.RIGHT);
               mi.setIcon(new ImageIcon(url));
           }
           String astr = getResourceString(cmd + actionSuffix);
           if (astr == null) {
               astr = cmd;
           }
           mi.setActionCommand(astr);
           Action a = getAction(astr);
           if (a != null) {
               mi.addActionListener(a);
               a.addPropertyChangeListener(createActionChangeListener(mi));
               mi.setEnabled(a.isEnabled());
           } else {
               mi.setEnabled(false);
           }
           menuItems.put(cmd, mi);
           return mi;
       }

       /**
        * This is the hook through which all popup menu items are
        * created.  It registers the result with the menuitem
        * hashtable so that it can be fetched with createMenuItem().
        * @see #createMenuItem
        */
       void createPopupMenus() {
               pm=new JPopupMenu();
       String[] itemKeys = tokenize(getResourceString("popupmenu"));
       for (int i = 0; i < itemKeys.length; i++) {
           if (itemKeys[i].equals("-")) {
               pm.addSeparator();
           } else {
               JMenuItem mi = createMenuItem(itemKeys[i]);
               pm.add(mi);
           }
         }
       }
       /**
        * This is the hook through which all menu items are
        * created.  It registers the result with the menuitem
        * hashtable so that it can be fetched with getMenuItem().
        * @see #getMenuItem
        */
       protected JMenuItem createMenuItem(String cmd, int shortcut, boolean shift) {
           int trueshortcutkeyInt =  new MenuShortcut(shortcut, true).getKey();
           int shortcutkeyInt =  new MenuShortcut(shortcut, false).getKey();
           JMenuItem mi = new JMenuItem(getResourceString(cmd + labelSuffix));
           if (shortcut==0)
                   mi = new JMenuItem(getResourceString(cmd + labelSuffix));
           else {
                   if (shift) {
                           mi = new JMenuItem(getResourceString(cmd + labelSuffix));//, trueshortcutkeyInt);
                           mi.setAccelerator(
                             KeyStroke.getKeyStroke(trueshortcutkeyInt, InputEvent.CTRL_MASK | InputEvent.SHIFT_MASK) );
                   } else {
                           mi = new JMenuItem(getResourceString(cmd + labelSuffix));//, shortcutkeyInt);
                           mi.setAccelerator(
                             KeyStroke.getKeyStroke(shortcutkeyInt, InputEvent.CTRL_MASK) );
                   }
           }
           URL url = getResource(cmd + imageSuffix);
           if (url != null) {
               mi.setHorizontalTextPosition(JButton.RIGHT);
               mi.setIcon(new ImageIcon(url));
           }
           String astr = getResourceString(cmd + actionSuffix);
           if (astr == null) {
               astr = cmd;
           }
           mi.setActionCommand(astr);
           Action a = getAction(astr);
           if (a != null) {
               mi.addActionListener(a);
               a.addPropertyChangeListener(createActionChangeListener(mi));
               mi.setEnabled(a.isEnabled());
           } else {
               mi.setEnabled(false);
           }
           menuItems.put(cmd, mi);
           return mi;
       }

        // Yarked from JMenu, ideally this would be public.
        protected PropertyChangeListener createActionChangeListener(AbstractButton b) {
            return new ActionChangedListener(b);
        }

        // Yarked from JMenu, ideally this would be public.
        private class ActionChangedListener implements PropertyChangeListener {
            AbstractButton menuItem;

            ActionChangedListener(AbstractButton mi) {
                super();
                this.menuItem = mi;
            }
            public void propertyChange(PropertyChangeEvent e) {
                String propertyName = e.getPropertyName();
                //System.out.println("propertyName=" +propertyName);
               if (e.getPropertyName().equals(Action.NAME)) {
                    String text = (String) e.getNewValue();
                    menuItem.setText(text);
                } else if (propertyName.equals("enabled")) {
                    Boolean enabledState = (Boolean) e.getNewValue();
                    menuItem.setEnabled(enabledState.booleanValue());
                }
            }
        }


        public void positionWindow() {
                Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
                Dimension window = getSize();
                if (window.width==0)
                        return;
                int left = screen.width/2-window.width/2;
                int top = (screen.height-window.height)/4;
                if (top<0) top = 0;
                if (nWindows<=0 || xoffset>8*XINC)
                        {xoffset=0; yoffset=0;}
                setLocation(left+xoffset, top+yoffset);
                xoffset+=XINC; yoffset+=YINC;
                nWindows++;
        }

        void setWindowTitle(String title) {
                Menus.updateWindowMenuItem(getTitle(), title);
                setTitle(title);
        }

        public void create(String name, String text) {
            editor.setText(text);
            curFont=editor.getFont();
            fm = editor.getFontMetrics(curFont);
            //System.out.println("editor.getBounds()=" + editor.getBounds());
            row=getMaxRow();
            //createlineNum(row, num);
            if (IJ.isMacOSX()) IJ.wait(25); // needed to get setCaretPosition() on OS X
                setWindowTitle(name);
                /*if (name.endsWith(".txt") || name.endsWith(".ijm") || name.indexOf(".")==-1) {
                        // 'baseCount' in MacroInstaller must be updated if items are added to this menu
                        mb=getMenubar();
                        macrosMenu=createMenu("macro");
                        mb.add(macrosMenu);
                        if (text.indexOf("macro ")!=-1)
                                installMacros(text, false);
                } else {
                        fileMenu.addSeparator();
                        JMenuItem item = createMenuItem("compileandrun", new MenuShortcut(KeyEvent.VK_R).getKey(), false);
                        fileMenu.add(item);
                    }*/
                if (IJ.getInstance()!=null && !dontShowWindow)
                    setVisible(true);
                if (dontShowWindow) {
                        dispose();
                        dontShowWindow = false;
                }
                WindowManager.setWindow(this);
                changes = false;
                repaint();
        }


        public void createMacro(String name, String text) {
                create(name, text);
                JMenuItem item = createMenuItem("converttoplugin");
                editMenu.add(item);
        }

        void installMacros(String text, boolean installInPluginsMenu) {
                installer = new MacroInstaller();
                installer.setFileName(getTitle());
                int nShortcutsOrTools = installer.install(text, macrosMenu);
                if (installInPluginsMenu || nShortcutsOrTools>0)
                        installer.install(null);
                dontShowWindow = installer.isAutoRunAndHide();
        }

        public void open(String dir, String name) {
                path = dir+name;
                File file = new File(path);
                int size = (int)file.length();
                if (size>MAX_SIZE && !(IJ.isJava2()||IJ.isMacintosh())) {
                        IJ.error("This file is too large for ImageJ to open.\n"
                                +" \n"
                                +"	  File size: "+size+" bytes\n"
                                +"	  Max. size: "+MAX_SIZE+" bytes");
                        dispose();
                        return;
                }

                try {
                        sb = new StringBuilder();
                        BufferedReader r = new BufferedReader(new FileReader(file));
                        while (true) {
                                String s=r.readLine();
                                if (s==null){
                                    break;
                                }
                                else{
                                    s+="\n";
                                    sb.append(s);
                                }
                        }
                        r.close();
                        text = new String(sb);
                        create(name, text);
                        changes = false;
                }
                catch (Exception e) {
                        IJ.error(e.getMessage());
                        return;
                }
        }

        int getMaxRow(){
            int row=1;
            text = editor.getText();
            if(text.equals("")){num = 1;length = 1;return 1;}
            char[] lchars = new char[text.length()];
            lchars = text.toCharArray();
            for (int i=0; i<lchars.length; i++) {
                if (lchars[i]=='\r') {
                   continue;
                }
                if (lchars[i] == '\n') { //
                    row++;
                }
            }
            return row;
        }


        public String getText() {
                if (editor==null)
                        return "";
                else
                        return editor.getText();
        }

        public void display(String title, String text) {
                editor.selectAll();
                editor.replaceSelection(text);
                editor.setCaretPosition(0);
                setWindowTitle(title);
                changes = false;
                if (IJ.getInstance()!=null)
                        setVisible(true);
                WindowManager.setWindow(this);
        }


        void compileAndRun() {
                if (path==null)
                        saveAs();
                if (path!=null) {
                        save();
                        IJ.runPlugIn("ij.plugin.Compiler", path);
                }
        }

        void runMacro() {
                int start = editor.getSelectionStart();
                int end = editor.getSelectionEnd();
                String text;
                if (start==end)
                        text = editor.getText();
                else
                        text = editor.getSelectedText();
                new MacroRunner(text);
        }

        void save() {
                if (path==null) {
                        saveAs();
                        return;
                }
                File f = new File(path);
                if (f.exists() & !f.canWrite()) {
                        IJ.showMessage("Editor", "Unable to save because file is write-protected. \n \n" + path);
                        return;
                }
                String text = editor.getText();
                char[] chars = new char[text.length()];
                text.getChars(0, text.length(), chars, 0);
                try {
                        BufferedReader br = new BufferedReader(new CharArrayReader(chars));
                        BufferedWriter bw = new BufferedWriter(new FileWriter(path));
                        while (true) {
                                String s = br.readLine();
                                if (s==null) break;
                                bw.write(s, 0, s.length());
                                bw.newLine();
                        }
                        bw.close();
                        IJ.showStatus(text.length()+" chars saved to " + path);
                        changes = false;
                } catch
                        (IOException e) {}
        }

        void saveAs() {
                String name1 = getTitle();
                if (defaultDir==null) {
                        if (name1.endsWith(".txt"))
                                defaultDir = Menus.getMacrosPath();
                        else
                                defaultDir = Menus.getPlugInsPath();
                }
                SaveDialog sd = new SaveDialog("Save Plugin As...", defaultDir, name1, null);
                String name2 = sd.getFileName();
                String dir = sd.getDirectory();
                if (name2!=null) {
                        if (name2.endsWith(".java"))
                                updateClassName(name1, name2);
                        path = dir+name2;
                        save();
                        changes = false;
                        setWindowTitle(name2);
                }
        }

        /** Changes a plugins class name to reflect a new file name. */
        public void updateClassName(String oldName, String newName) {
                if (newName.indexOf("_")<0)
                        IJ.showMessage("Plugin Editor", "Plugins without an underscore in their name will not\n"
                                +"be automatically installed when ImageJ is restarted.");
                if (oldName.equals(newName) || !oldName.endsWith(".java") || !newName.endsWith(".java"))
                        return;
                oldName = oldName.substring(0,oldName.length()-5);
                newName = newName.substring(0,newName.length()-5);
                String text1 = editor.getText();
                int index = text1.indexOf("public class "+oldName);
                if (index<0)
                        return;
                String text2 = text1.substring(0,index+13)+newName+text1.substring(index+13+oldName.length(),text1.length());
                editor.setText(text2);
        }

        void find(String s) {
                if (s==null) {
                        GenericDialog gd = new GenericDialog("Find", this);
                        gd.addStringField("Find: ", searchString, 20);
                        String[] labels = {"Case Sensitive", "Whole Words"};
                        boolean[] states = {caseSensitive, wholeWords};
                        //boolean[] states = new boolean[2];
                        //states[0]=caseSensitive; states[1]=wholeWords;
                        gd.addCheckboxGroup(1, 2, labels, states);
                        gd.showDialog();
                        if (gd.wasCanceled())
                                return;
                        s = gd.getNextString();
                        caseSensitive = gd.getNextBoolean();
                        wholeWords = gd.getNextBoolean();
                }
                if (s.equals(""))
                        return;
                String text = editor.getText();
                String s2 = s;
                if (!caseSensitive) {
                        text = text.toLowerCase(Locale.US);
                        s = s.toLowerCase(Locale.US);
                }
                int index = -1;
                if (wholeWords) {
                        int position = editor.getCaretPosition()+1;
                        while (true) {
                                index = text.indexOf(s, position);
                                if (index==-1) break;
                                if (isWholeWordMatch(text, s, index)) break;
                                position = index + 1;
                                if (position>=text.length()-1)
                                        {index=-1; break;}
                        }
                } else
                        index = text.indexOf(s, editor.getCaretPosition()+1);
                if (index<0)
                        {IJ.beep(); return;}
                editor.setSelectionStart(index);
                editor.setSelectionEnd(index+s.length());
                searchString = s2;
        }

        boolean isWholeWordMatch(String text, String word, int index) {
                char c = index==0?' ':text.charAt(index-1);
                if (Character.isLetterOrDigit(c) || c=='_') return false;
                c = index+word.length()>=text.length()?' ':text.charAt(index+word.length());
                if (Character.isLetterOrDigit(c) || c=='_') return false;
                return true;
        }

        void gotoLine() {
                GenericDialog gd = new GenericDialog("Go to Line", this);
                gd.addNumericField("Go to line number: ", lineNumber, 0);
                gd.showDialog();
                if (gd.wasCanceled())
                        return;
                int n = (int)gd.getNextNumber();
                if (n<1) return;
                String text = editor.getText();
                char[] chars = new char[text.length()];
                chars = text.toCharArray();
                int count=1, loc=0;
                for (int i=0; i<chars.length; i++) {
                        if (chars[i]=='\n') count++;
                        if (count==n)
                                {loc=i+1; break;}
                }
                num=n;
                length=1;
                setStatusLabel(num, length);
                if(n == 1)loc-=1;
                editor.setCaretPosition(loc);
                lineNumber = n;
        }


        void zapGremlins() {
                String text = editor.getText();
                char[] chars = new char[text.length()];
                chars = text.toCharArray();
                int count=0;
                boolean inQuotes = false;
                char quoteChar = 0;
                for (int i=0; i<chars.length; i++) {
                        char c = chars[i];
                        if (!inQuotes && (c=='"' || c=='\'')) {
                                inQuotes = true;
                                quoteChar = c;
                        } else  {
                                if (inQuotes && (c==quoteChar || c=='\n'))
                                inQuotes = false;
                        }
                        if (!inQuotes && c!='\n' && c!='\t' && (c<32||c>127)) {
                                count++;
                                chars[i] = ' ';
                                //IJ.log(""+(0+c));
                        }
                }
                if (count>0) {
                        text = new String(chars);
                        editor.setText(text);
                }
                if (count>0)
                        IJ.showMessage("Zap Gremlins", count+" invalid characters converted to spaces");
                else
                        IJ.showMessage("Zap Gremlins", "No invalid characters found");
        }

        void convertToPlugin() {
                if (!getTitle().endsWith(".txt")) return;
                String text = editor.getText();
                if (text==null || text.equals("")) {
                        IJ.runPlugIn("ij.plugin.NewPlugin", " ");
                        return;
                }
                if (text.indexOf("{")>-1) {
                        IJ.showMessage("Convert to Plugin", "Conversion limited to recorder generated macro code.");
                        return;
                }
                StringTokenizer st = new StringTokenizer(text, "\n");
                int n = st.countTokens();
                String line;
                StringBuffer sb = new StringBuffer();
            try {
                 for(int i=0; i<n; i++) {
                  line = st.nextToken();
                   if (line!=null && line.length()>3) {
                  sb.append("\t\tIJ.");
                  if (line.startsWith("//run"))
                          line = line.substring(2);
                  sb.append(line);
                  sb.append('\n');
                    }
                   }
                 }
                  catch (Exception ex) {
                }
                NewPlugin np = (NewPlugin)IJ.runPlugIn("ij.plugin.NewPlugin", new String(sb));
                ij.plugin.frame.Editor ed = np.getEditor();
                String title = getTitle();
                if (title.equals("Macro.txt"))
                        title = "Converted_Macro";
                if (title.endsWith(".txt")) title = title.substring(0, title.length()-4);
                if (title.indexOf('_')==-1) title += "_";
                title += ".java";
                ed.updateClassName(ed.getTitle(), title);
                ed.setTitle(title);
        }

        void changeFontSize(boolean larger) {
            int in = fontSize;
            if (larger) {
                fontSize++;
                if (fontSize==sizes.length)
                    fontSize = sizes.length-1;
            } else {
                fontSize--;
                if (fontSize<0)
                    fontSize = 0;
            }
            IJ.showStatus(sizes[fontSize]+" point");
            setFont();
        }

        void saveSettings() {
                    Prefs.set(FONT_SIZE, fontSize);
                    Prefs.set(FONT_MONO, monospaced.getState());
                    IJ.showStatus("Font settings saved (size="+sizes[fontSize]+", monospaced="+monospaced.getState()+")");
        }

        void setFont() {
            curFont = new Font(getFontName(), Font.PLAIN, sizes[fontSize]);
            editor.setFont(curFont);
            //lineNoEditor.setFont(editor.getFont());
        }

        String getFontName() {
            return monospaced.getState()?"Monospaced":"SansSerif";
        }
        public void setFont(Font font) {
                curFont=font;
                editor.setFont(font);
                //lineNoEditor.setFont(font);
        }

        public static void setDefaultDirectory(String defaultDirectory) {
                defaultDir = defaultDirectory;
        }
        void evaluateLine() {
                int start = editor.getSelectionStart();
                int end = editor.getSelectionEnd();
                if (end>start)
                        {runMacro(); return;}
                String text = editor.getText();
                while (start>0) {
                        start--;
                        if (text.charAt(start)=='\n')
                                {start++; break;}
                }
                while (end<text.length()-1) {
                        end++;
                        if (text.charAt(end)=='\n')
                                break;
                }
                editor.setSelectionStart(start);
                editor.setSelectionEnd(end);
                runMacro();
        }

        /**
         * Print the contents of the text pane using the java.awt.print API
         * Note that this API does not work efficiently in Java 1.2
         * All the hard work is done by the PrintableDocument class.
         **/
        void print() {
            // Get a PrinterJob object from the system
            PrinterJob pj = PrinterJob.getPrinterJob();
            boolean pDialogState = false;
                 try {
                     PrintRequestAttributeSet aset = new HashPrintRequestAttributeSet();
                     PrintableDocument pd = new PrintableDocument(getEditor());
                     // Tell the PrinterJob what we want to print
                     pj.setPageable(pd);
                         pDialogState = pj.printDialog(aset);
                             if (pDialogState) {
                                    pj.print(aset);
                     }

                 } catch (java.security.AccessControlException ace) {
                     IJ.log(""+ ace);
                 }
                 catch (PrinterException e) {
                         IJ.log(""+e);
                 }
        }


        public void checkBox_itemStateChanged(ItemEvent e) {
                //JCheckBoxMenuItem item = (JCheckBoxMenuItem)e.getSource();
                  setFont();
        }

        public void setIsMacroWindow(boolean mw) {
                isMacroWindow = mw;
        }

        public void lostOwnership (Clipboard clip, Transferable cont) {}

        void textFieldUpdate(DocumentEvent e){
            try {
                // first few textValueChanged events may be bogus
                if (eventCount>2 || !IJ.isMacOSX() && eventCount>1)
                        changes = true;
                if (IJ.isMacOSX()) // screen update bug work around
                        editor.setCaretPosition(editor.getCaretPosition());

            } catch (Exception ex) {
            }
      }
      void setbg(){
          editor.setSelectionColor(new Color(255, 255, 207));
          editor.setSelectedTextColor(editor.getForeground());
          editor.setSelectionStart(offset[num-1]);
          editor.setSelectionEnd(offset[num]-1);
      }

      void setStatusLabel(int num, int length){
          statusLabel.setText(""+num+": "+ length+"                   ");
      }

        public void insertUpdate(DocumentEvent e){
            if (isMacroWindow) return;
           try {
                eventCount++;
                row=getMaxRow();
            } catch (Exception ex) {

            }
       }
       public void removeUpdate(DocumentEvent e){
           if (isMacroWindow) return;
          try {
               eventCount--;
               row=getMaxRow();
             } catch (Exception ex) {

             }
           }

       public void changedUpdate(DocumentEvent e){}

       /** Overrides close() in PlugInFrame. */
      public void close() {
              boolean okayToClose = true;
              ImageJ ij = IJ.getInstance();
              if (!getTitle().equals("Errors") && changes && !IJ.macroRunning() && ij!=null && !ij.quitting()) {
                      SaveChangesDialog d = new SaveChangesDialog(this, getTitle());
                      if (d.cancelPressed())
                              okayToClose = false;
                      else if (d.savePressed())
                              save();
              }
              if (okayToClose) {
                      setVisible(false);
                      dispose();
                      WindowManager.removeWindow(this);
                      nWindows--;
              }
      }

       /** Override windowActivated in PlugInFrame to
                prevent Mac menu bar from being installed. */
        public void windowActivated(WindowEvent e) {
                WindowManager.setWindow(this);
        }

        public void windowClosing(WindowEvent e) {
                close();
        }

        public void mousePressed (MouseEvent e) {
            int x=e.getX(), y=e.getY();
            try {
                    //getRowArray();
            } catch (Exception ex) {

            }
                if (e.isPopupTrigger() || e.isMetaDown())
                        pm.show(e.getComponent(),x,y);
        }

        public void mouseExited (MouseEvent e) {
        }
        public void mouseReleased (MouseEvent e) {
        }
        public void mouseClicked (MouseEvent e) {}
        public void mouseEntered (MouseEvent e) {}

        public void mouseWheelMoved(MouseWheelEvent e) {
                synchronized(this) {
                        int rot = e.getWheelRotation();
                        int rowHeight = 11;

                        if (rot<-1) rot = -1;
                        if (rot>1) rot = 1;

                        if(curRow >= 1 && curRow < row && rot == 1)
                        curRow++;
                        if(curRow > 1 && rot == -1)
                            curRow--;

                        rowHeight=fm.getHeight()+fm.getLeading();
                        rot*=rowHeight*2;
                        scrollBar.setValue(scrollBar.getValue()+rot);
                        if(curRow > row)curRow=row;
                        if(curRow < 1)curRow=1;
                }
        }


        public void keyPressed(KeyEvent e) {
            if(e.getKeyCode() == e.VK_PAGE_UP){
            }
            else if(e.getKeyCode() == e.VK_PAGE_DOWN){
            }
            else if(e.getKeyCode() == e.VK_UP){
             }
            else if(e.getKeyCode() == e.VK_DOWN){
            }
            else if(e.getKeyCode() == e.VK_LEFT){
            }
            else if(e.getKeyCode() == e.VK_RIGHT){
            }
            else if(e.getKeyCode() == e.VK_HOME){
                setStatusLabel(num, length=1);
            }
            if(e.getKeyCode() == e.VK_END){
                setStatusLabel(num, length=llength[num-1]);
            }

        }
        public void keyReleased(KeyEvent e) {
            /**/if(e.getKeyCode() == e.VK_PAGE_UP){
            }
            else if(e.getKeyCode() == e.VK_PAGE_DOWN){
            }
            else if(e.getKeyCode() == e.VK_UP){
            }
            else if(e.getKeyCode() == e.VK_DOWN){
            }
            else if(e.getKeyCode() == e.VK_LEFT){
            }
            else if(e.getKeyCode() == e.VK_RIGHT){
            }
            else if(e.getKeyCode() == e.VK_HOME){
            }
            if(e.getKeyCode() == e.VK_END){
            }

      }
        public void keyTyped(KeyEvent e) {
        }

        public void update(Graphics g){
            paint(g);
            repaint();
        }
        public void paint(Graphics g){
            //createlineNum(row, num);
            Graphics2D g2D = (Graphics2D)g;
            container.repaint();
        }

        /**
         * Suffix applied to the key used in resource file
         * lookups for an button enabled.
         */
        public static final String undoSuffix = "Enabled";

        /**
         * Suffix applied to the key used in resource file
         * lookups for an image.
         */
        public static final String imageSuffix = "Image";

        /**
         * Suffix applied to the key used in resource file
         * lookups for a label.
         */
        public static final String labelSuffix = "Label";

        /**
         * Suffix applied to the key used in resource file
         * lookups for an action.
         */
        public static final String actionSuffix = "Action";

        /**
         * Suffix applied to the key used in resource file
         * lookups for tooltip text.
         */

        public static final String tipSuffix = "Tooltip";

        public static final String cutAction = "cut";
        public static final String copyAction = "copy";
        public static final String exitAction = "exit";
        public static final String pasteAction = "paste";
        public static final String deleteAction = "delete-next";
        public static final String openAction = "open";
        public static final String newAction  = "new";
        public static final String saveAction = "save";
        public static final String saveAsAction = "save-as";
        public static final String findAction = "find";
        public static final String findnextAction = "findnext";
        public static final String gotolineAction = "gotoline";
        public static final String compileandrunAction = "compileandrun";
        public static final String printAction = "print";
        public static final String savesettingsAction = "savesettings";
        public static final String monospacedAction = "monospaced";
        public static final String smalerAction = "smaler";
        public static final String largerAction = "larger";
        public static final String runmacroAction = "runmacro";
        public static final String evaluatelineAction = "evaluateline";
        public static final String abortmacroAction = "abortmacro";
        public static final String installmacrosAction = "installmacros";

        // --- action implementations -----------------------------------

        /**
         * Listener for the edits on the current document.
         */
        protected UndoableEditListener undoHandler = new UndoHandler();

        /** UndoManager that we add edits to. */
        protected UndoManager undo = new UndoManager();
        private UndoAction undoAction = new UndoAction();
        private RedoAction redoAction = new RedoAction();

        /**
        * Actions defined by the Editor class
        */
       private Action[] defaultActions = {
                                         new CopyAction(),
                                         new CutAction(),
                                         new ExitAction(),
                                         new PasteAction(),
                                         new DeleteAction(),
                                         new NewAction(),
                                         new OpenAction(),
                                         new SaveAction(),
                                         new SaveAsAction(),
                                         new PrintAction(),
                                         new SmalerAction(),
                                         new FindAction(),
                                         new FindNextAction(),
                                         new GoToLineAction(),
                                         new LargerAction(),
                                         new MonospacedAction(),
                                         new SaveSettingsAction(),
                                         new CompileAndRunAction(),
                                         new RunMacroAction(),
                                         new EvaluateLineAction(),
                                         new AbortMacrosAction(),
                                         new InstallMacroAction(),
                                         undoAction,
                                         redoAction
       };

       class UndoHandler implements UndoableEditListener {

            /**
             * Messaged when the Document has created an edit, the edit is
             * added to <code>undo</code>, an instance of UndoManager.
             */
            public void undoableEditHappened(UndoableEditEvent e) {
                undo.addEdit(e.getEdit());
                undoAction.update();
                redoAction.update();
            }
        }
        class OpenAction extends NewAction {

            OpenAction() {
                super(openAction);
            }

            public void actionPerformed(ActionEvent e) {
                IJ.open();
            }
        }

        class CopyAction extends AbstractAction {

            CopyAction() {
                super(copyAction);
            }

            public void actionPerformed(ActionEvent e) {
                editor.copy();
            }
        }

        class CutAction extends AbstractAction {

            CutAction() {
                super(cutAction);
            }

            public void actionPerformed(ActionEvent e) {
                editor.cut();//cut();
            }
        }

        class ExitAction extends AbstractAction {

            ExitAction() {
                super(exitAction);
            }

            public void actionPerformed(ActionEvent e) {
                close();
            }
        }

        class PasteAction extends AbstractAction {

            PasteAction() {
                super(pasteAction);
            }

            public void actionPerformed(ActionEvent e) {
                editor.paste();
            }
        }

        class DeleteAction extends AbstractAction {

            DeleteAction() {
                super(deleteAction);
            }

            public void actionPerformed(ActionEvent e) {
                //delete-next;
            }
        }

        class SaveAction extends AbstractAction {

            SaveAction() {
                super(saveAction);
            }

            public void actionPerformed(ActionEvent e) {
                save();
            }
        }

        class SaveAsAction extends AbstractAction {

            SaveAsAction() {
                super(saveAsAction);
            }

            public void actionPerformed(ActionEvent e) {
                saveAs();
            }
        }

        class NewAction extends AbstractAction {

            NewAction() {
                super(newAction);
            }

            NewAction(String nm) {
                super(nm);
            }

            public void actionPerformed(ActionEvent e) {
                IJ.runPlugIn("ij.plugin.NewPlugin", "");
            }
        }

        /**
         * Really lame implementation of an print command
         */
        class PrintAction extends AbstractAction {

            PrintAction() {
                super(printAction);
            }

            public void actionPerformed(ActionEvent e) {
                print();
            }
        }
        /**
         * Really lame implementation of an smalerfont command
         */
        class SmalerAction extends AbstractAction {

            SmalerAction() {
                super(smalerAction);
            }

            public void actionPerformed(ActionEvent e) {
                changeFontSize(false);
            }
        }
        /**
         * Really lame implementation of an find text command
         */
        class FindAction extends AbstractAction {

            FindAction() {
                super(findAction);
            }

            public void actionPerformed(ActionEvent e) {
                find(null);
            }
        }
        /**
         * Really lame implementation of an find next text command
         */
        class FindNextAction extends AbstractAction {

            FindNextAction() {
                super(findnextAction);
            }

            public void actionPerformed(ActionEvent e) {
                find(searchString);
            }
        }
        /**
         * Really lame implementation of an go to line command
         */
        class GoToLineAction extends AbstractAction {

            GoToLineAction() {
                super(gotolineAction);
            }

            public void actionPerformed(ActionEvent e) {
                gotoLine();
            }
        }
        /**
         * Really lame implementation of an lager font command
         */
        class LargerAction extends AbstractAction {

            LargerAction() {
                super(largerAction);
            }

            public void actionPerformed(ActionEvent e) {
                changeFontSize(true);
            }
        }
        /**
         * Really lame implementation of an monospaced font command
         */
        class MonospacedAction extends AbstractAction {

            MonospacedAction() {
                super(monospacedAction);
            }

            public void actionPerformed(ActionEvent e) {
                setFont();
            }
        }
        /**
         * Really lame implementation of an save settings font command
         */
        class SaveSettingsAction extends AbstractAction {

           SaveSettingsAction() {
                super(savesettingsAction);
            }

            public void actionPerformed(ActionEvent e) {
                print();
            }
        }
        /**
         * Really lame implementation of an compile and run command
         */
        class CompileAndRunAction extends AbstractAction {

           CompileAndRunAction() {
                super(compileandrunAction);
            }

            public void actionPerformed(ActionEvent e) {
                compileAndRun();
            }
        }
        /**
         * Really lame implementation of an compile and run command
         */
        class RunMacroAction extends AbstractAction {

           RunMacroAction() {
                super(runmacroAction);
            }

            public void actionPerformed(ActionEvent e) {
                runMacro();
            }
        }
        /**
         * Really lame implementation of an compile and run command
         */
        class EvaluateLineAction extends AbstractAction {

           EvaluateLineAction() {
                super(evaluatelineAction);
            }

            public void actionPerformed(ActionEvent e) {
                                evaluateLine();
            }
        }
        /**
         * Really lame implementation of an compile and run command
         */
        class AbortMacrosAction extends AbstractAction {

           AbortMacrosAction() {
                super(abortmacroAction);
            }

            public void actionPerformed(ActionEvent e) {
                Interpreter.abort();
                IJ.beep();
            }
        }
        /**
         * Really lame implementation of an compile and run command
         */
        class InstallMacroAction extends AbstractAction {

           InstallMacroAction() {
                super(installmacrosAction);
            }

            public void actionPerformed(ActionEvent e) {
                installMacros(editor.getText(), true);
            }
        }
        class UndoAction extends AbstractAction {
            public UndoAction() {
                super("Undo");
                setEnabled(false);
            }

            public void actionPerformed(ActionEvent e) {
                try {
                    undo.undo();
                } catch (CannotUndoException ex) {
                    System.out.println("Unable to undo: " + ex);
                    ex.printStackTrace();
                }
                update();
                redoAction.update();
            }

            protected void update() {
                if(undo.canUndo()) {
                    setEnabled(true);
                    putValue(Action.NAME, "Undo");//undo.getUndoPresentationName());
                }
                else {
                    setEnabled(false);
                    putValue(Action.NAME, "Undo");
                }
            }
        }

        class RedoAction extends AbstractAction {
            public RedoAction() {
                super("Redo");
                setEnabled(false);
            }

            public void actionPerformed(ActionEvent e) {
                try {
                    undo.redo();
                } catch (CannotRedoException ex) {
                    System.out.println("Unable to redo: " + ex);
                    ex.printStackTrace();
                }
                update();
                undoAction.update();
            }

            protected void update() {
                if(undo.canRedo()) {
                    setEnabled(true);
                    putValue(Action.NAME, "Redo");//undo.getRedoPresentationName());
                }
                else {
                    setEnabled(false);
                    putValue(Action.NAME, "Redo");
                }
            }
        }

        class ColoredSquare implements Icon {
            Color color;
            public ColoredSquare(Color c) {
                this.color = c;
            }

            public void paintIcon(Component c, Graphics g, int x, int y) {
                Color oldColor = g.getColor();
                g.setColor(color);
                g.fill3DRect(x,y,getIconWidth(), getIconHeight(), true);
                g.setColor(oldColor);
            }
            public int getIconWidth() { return 12; }
            public int getIconHeight() { return 12; }

        }
}

